function [X logsigma bestseed noisesize]= fit2Drep(Y, names, ps);

if ps.init > 0 % initialize with external file
  bestsoln= load(ps.initfile);
  Xbest = bestsoln.X;
end

if ps.init == 0 || ps.init == 2
  if strcmp(ps.runps.type, 'feat')
    [u, v] = pcacov(cov(Y'));
  else
    [u, v] = pcacov(Y);
  end
  v(find(v<0))=0;
  Xpca = u(:, 1:2);
end

switch ps.init
  case 0
    X = Xpca;
  case 1
    X = Xbest;
  case 2
    error('not implemented'); % need to compare scores
end

figure(1)
scatter(X(:,1), X(:,2), 'k.');
text(X(:,1), X(:,2), names);
axis tight; axis equal;
title('pca');
drawnow;

noisesize = ps.noisesize;
score = [];
Xnew = {};
for i = 1:ps.nloops
  randn('seed', i);
  rand('seed', i);
  
  options = foptions;
  options(1) = 0;
  options(9) = 0;
  options(14) = 5000;
  
  if i == 1
    Xinput = X;
  else
    Xinput = X + noisesize*rand(size(X));
  end

  try
  [Xnew{i}, options] = scg('kemplikelihood', [1.6, Xinput(:)'], options, ...
			   'kempgradient', Y, ps);
  catch
    [void, errid] = lasterr;
    disp(errid); options(8) = Inf;
  end
  score(i) = -options(8);
  disp(sprintf('Score %d: %.2f', i, -options(8)));
end

score(score == 0) = -inf;
[m,mind] = max(score);
bestseed = mind;
Xfinal = Xnew{mind};

logsigmafinal = Xfinal(1); 
Xfinal = reshape(Xfinal(2:end), size(Y,1), 2);
figure(2)
scatter(Xfinal(:,1), Xfinal(:,2), 'k.');
text(Xfinal(:,1), Xfinal(:,2), names);
axis tight; axis equal;
title('gplvm');
drawnow;

X = Xfinal; logsigma = logsigmafinal;

